/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille

ludovic.apvrille AT enst.fr

This software is a computer program whose purpose is to allow the 
edition of TURTLE analysis, design and deployment diagrams, to 
allow the generation of RT-LOTOS or Java code from this diagram, 
and at last to allow the analysis of formal validation traces 
obtained from external tools, e.g. RTL from LAAS-CNRS and CADP 
from INRIA Rhone-Alpes.

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

/**
* Class SimpleProcessThread
* For basic execution of processes
* Creation: 2010
* @version 1.1 26/10/2010
* @author Ludovic APVRILLE
* @see
*/

package myutil;


import java.io.*;


public class SimpleProcessThread extends Thread {
    private String cmd;
    BufferedReader proc_in;
    private Process proc;
    private boolean isStarted = false;
    private boolean go = true;
    private ErrorThread et;
    
    
    public SimpleProcessThread(String _cmd) {
        cmd = _cmd;
    }
	
	public void go() {
		this.start();
	}
    
    public boolean isStarted() {
        return isStarted;
    }
    
    public void stopProcess() {
        go = false;
		try {
			proc_in.close();
		} catch (Exception e) {}
		try {
			proc.destroy();
		} catch (Exception e) {}
        proc_in = null;
		proc = null;
    }
    
    public void run() {
        isStarted = true;
        TraceManager.addDev("Starting process for command " + cmd);
        proc = null;
        //BufferedReader in = null;
        String str = null;
        //PrintStream out = null;
        
        try {
            TraceManager.addDev("Going to start command " + cmd);
            
            proc = Runtime.getRuntime().exec(cmd);
            
            proc_in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
            
            while ( ((str = proc_in.readLine()) != null)  && (go == true)){    
                TraceManager.addDev("Out " + str);          
            }
            
            
        } catch (Exception e) {
            TraceManager.addError("Exception [" + e.getMessage() + "] occured when executing " + cmd);
        }
        TraceManager.addDev("Ending command " + cmd);
        
		try {
			if (proc_in != null) {
				proc_in.close();
			}
		} catch (Exception e) {
		}
		
		try {
			if (proc != null) {
				proc.destroy();
			}
		} catch (Exception e) {
		}
        
        isStarted = false;
		
    }
}
