/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille

ludovic.apvrille AT enst.fr

This software is a computer program whose purpose is to allow the
edition of Latex documents

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

/**
 * Class JPanelInfo
 * Creation: 11/06/2010
 * Version 1.0 11/06/2010
 * @author Ludovic APVRILLE
 * @see
 */

package ui;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import latexstructure.*;
import myutil.*;
import ui.tree.*;
import ui.*;


public	class JPanelInfo extends JPanel implements ActionListener /*ListSelectionListener*/	{
   
    private LatexStructure ls;
	
	private MainGUI mgui;
	
	//private Vector elements;
	
	//private JList listSlides;
	
	// JTree
    public JDiagramTree dtree;
    public DiagramTreeModel dtm;
	
	private JCheckBox flatView;
	private JCheckBox expandTree;
	private JCheckBox showSections;
	private JCheckBox showSlides;
	private JCheckBox showOthers;
	private JCheckBox showLabels;
	
	private JPanelForCompilation panelForCompilation;
	private JPanelFind panelForFind;
	
    /*private JButton removeButton;
	private JButton duplicateButton;
	private JButton appendButton;
	private JButton insertBeforeButton;
	private JButton insertAfterButton;
	private JComboBox elementToAdd;
	
	private JButton upButton;
	private JButton downButton;
	
	private String[] slides;
	private String[] datas;*/
    
    public JPanelInfo(MainGUI _mgui) {
        super();
        mgui = _mgui;
		
		//elements = new Vector();
		
		//loadSlides();
		makeComponents();
		setComponents();
    }
	
		
	public void makeComponents() {
		
		setLayout(new BorderLayout());
		
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		
		JPanel panel1 = new JPanel();
		panel1.setBorder(new javax.swing.border.TitledBorder("Tree manipulation"));
		GridBagLayout gridbag1 = new GridBagLayout();
        GridBagConstraints c1 = new GridBagConstraints();
		panel1.setLayout(gridbag1);
		
		
		/* The tree */
		dtree = new JDiagramTree(mgui, this);
        dtree.setCellRenderer(new DiagramTreeRenderer());
        ToolTipManager.sharedInstance().registerComponent(dtree);
        //dtree.setPreferredSize(new Dimension(100, 400));
        
		
		/* Panel for options on tree */
		c1.weighty = 1.0;
        c1.weightx = 1.0;
        c1.fill = GridBagConstraints.BOTH;
        c1.gridheight = 1;
		c1.gridwidth = GridBagConstraints.REMAINDER; //end row
        c1.fill = GridBagConstraints.HORIZONTAL;
		
		flatView = new JCheckBox("Flat view");
        flatView.addActionListener(this);
        panel1.add(flatView, c1);
		
		expandTree = new JCheckBox("Expand Tree");
        expandTree.addActionListener(this);
        panel1.add(expandTree, c1);
		
		showSections = new JCheckBox("Show sections");
        showSections.addActionListener(this);
        panel1.add(showSections, c1);
		
		showSlides = new JCheckBox("Show slides");
        showSlides.addActionListener(this);
        panel1.add(showSlides, c1);
		
		showLabels = new JCheckBox("Show labels");
        showLabels.addActionListener(this);
        panel1.add(showLabels, c1);
		
		showOthers = new JCheckBox("Show others");
        showOthers.addActionListener(this);
        panel1.add(showOthers, c1);
        
        panelForCompilation = new JPanelForCompilation(mgui);
        panelForCompilation.setPreferredSize(new Dimension(200, 100));
        
        panelForFind = new JPanelFind(mgui);
        
		JTabbedPane tpane = new JTabbedPane();
		tpane.add("find", panelForFind);
		tpane.add("tree", panel1);
		tpane.add("compilation", panelForCompilation);
		
		
		
		JScrollPane split01 = new JScrollPane(dtree);
		JScrollPane split02 = new JScrollPane(tpane);
		
		Dimension preferredDim = new Dimension(100, 400);
        split01.setPreferredSize(preferredDim);
        
        JSplitPane split1 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, split01, split02);
        //JSplitPane split1 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, split01, tpane);
         split1.setDividerLocation(400);
        //JScrollPane mainScrollPane = new JScrollPane(split1);
		//panel.add(panel1, BorderLayout.NORTH);
		//panel.add(panel2, BorderLayout.SOUTH);
        add(split1, BorderLayout.CENTER);
	}
	
	public void setComponents() {
		showSections.setSelected(true);
		showSlides.setSelected(true);
		showLabels.setSelected(true);
		showOthers.setSelected(true);
	}
	
	public void	actionPerformed(ActionEvent evt)  {
        
        // Compare the action command to the known actions.
        /*if (evt.getSource() == removeButton)  {
			removeSlide();
        } else if (evt.getSource() == duplicateButton)  {
			duplicateSlide();
        } else if (evt.getSource() == upButton)  {
			upSlide();
        } else if (evt.getSource() == downButton)  {
			downSlide();
        } else if (evt.getSource() == appendButton)  {
			appendSlide();
        } else if (evt.getSource() == insertBeforeButton)  {
			insertBeforeSlide();
        } else if (evt.getSource() == insertAfterButton)  {
			insertAfterSlide();
        } else */if (evt.getSource() == flatView)  {
			flatten();
        } else if (evt.getSource() == expandTree)  {
			expandCollapse();
        } else if (evt.getSource() == showSections)  {
			showSections();
        } else if (evt.getSource() == showSlides)  {
			showSlides();
        } else if (evt.getSource() == showLabels)  {
			showLabels();
        } else if (evt.getSource() == showOthers)  {
			showOthers();
        }
    }
	
	
	public void flatten() {
		if (ls != null) {
			changeMade();
			applyChange();
		}
	}
	
	public void expandCollapse() {
		if (expandTree.isSelected()) {
			dtree.expandAll();
		} else {
			//dtree.reinit();
			dtree.collapseAll();
		}
		changeMade();
		applyChange();
	}
	
	public void showSections() {
		LatexStructure.showSections = showSections.isSelected();
		dtree.forceUpdate();
	}
	
	public void showSlides() {
		LatexStructure.showSlides = showSlides.isSelected();
		dtree.forceUpdate();
	}
	
	public void showLabels() {
		LatexStructure.showLabels = showLabels.isSelected();
		dtree.forceUpdate();
	}
	
	public void showOthers() {
		LatexStructure.showOthers = showOthers.isSelected();
		dtree.forceUpdate();
	}
	
	public void setNewStructure(LatexStructure _ls) {
		setNewStructure(_ls, true);
		
	}
	
	public void setNewStructure(LatexStructure _ls, boolean _inform) {
		//TraceManager.addDev("Set new structure");
		ls = _ls;
		//ls.setFlat(flatView.isSelected());
		//dtree.reinit();
		/*dtree.forceUpdate();
		if (expandTree.isSelected()) {
			dtree.expandAll();
		}*/
		setComponents();
		updateList(_inform);
		expandCollapse();
	}
	
	public void updateList() {
		updateList(true);
	}
	
	public void updateList(boolean _inform) {
	}
	
	public void changeMade() {
		//System.out.println("Updating list");
		//listSlides.setListData(elements);
		//listSlides.repaint();
		//dtree.reinit();
		if (ls != null) {
			ls.setUpdate();
			/*ls.makeStructure(flatView.isSelected());
			dtree.forceUpdate();
			//dtree.update();
			if (expandTree.isSelected()) {
				dtree.expandAll();
			}*/
			//dtree.setRowHeight(dtree.getRowHeight());
			//dtree.repaint();
		}
	}
	
	public void applyChange() {
		if (ls != null) {
			ls.makeStructure(flatView.isSelected());
			dtree.forceUpdate();
			//dtree.update();
			if (expandTree.isSelected()) {
				dtree.expandAll();
			}
		} else {
			dtree.forceUpdate();
		}
	}
	
	public JPanelForCompilation getJPanelForCompilation() {
		return panelForCompilation;
	}
	

    
	
} // Class

